Authorization management

This section contains Authorization management proto files.

azman_service.proto

AuthorizationManager

This service allows managing authorization permissions for the product’s users. Permissions are granted according to roles’ memberships and the operations assigned to the roles. Administrators can create, modify, or delete roles, add or remove operations from a role, and add or remove members from a role. Roles can be defined at the scope level or system level.

  • Scope level roles authorize their members to perform actions only on entities that belong to the Scope.
  • System level roles authorize their members to perform actions on system level entities.

gRPC method definitions

gRPC method definitions
Method Name Request Type Response Type Description
CreateRole CreateRole
Request
CreateRole
Response
Creates a new role in the specified Scope.
GetRoleId GetRoleId
Request
GetRoleId
Response
Returns the name of the role that is associated with the specified role ID.
GetGkRoleId GetGkRoleId
Request
GetGkRoleId
Response
Returns the ID of the role that is associated with the specified role name.
DeleteRole DeleteRole
Request
DeleteRole
Response
Deletes the specified role.
ListRoles ListRoles
Request
ListRoles
Response
Returns a list of roles that belong to a given Scope.
CloneRole CloneRole
Request
CloneRole
Response
Creates a new role in the selected Scope by cloning the specified source role.
ResetFactoryRole ResetFactoryRole
Request
ResetFactoryRole
Response
Creates a new role in the selected Scope by cloning the specified source role.
GetRoleDetails GetRoleDetails
Request
GetRoleDetails
Response
Lists all details including operations and rules for the specified role.
SetRoleDescription SetRoleDescription
Request
SetRoleDescription
Response
Sets the role’s description.
AddRulesToRole AddRulesToRole
Request
AddRulesToRole
Response
Adds rules to a role.
RemoveRulesFromRole RemoveRulesFromRole
Request
RemoveRulesFromRole
Response
Removes rules from a role.
AddMemberToRole AddMemberToRole
Request
AddMemberToRole
Response
Assigns a member to a role.
RemoveMemberFromRole RemoveMemberFromRole
Request
RemoveMemberFromRole
Response
Removes a member from a role.
SetMemberLabel SetMemberLabel
Request
SetMemberLabel
Response
Sets label for specified member
GetMemberLabel GetMemberLabel
Request
GetMemberLabel
Response
Gets label for specified member
ListAssignedRoles ListAssignedRoles
Request
ListAssignedRoles
Response
Lists all members associated with the specified Scope.
ListScopeMembers ListScopeMembers
Request
ListScopeMembers
Response
Lists all members associated with the specified Scope.
ClearScopeMemberCache ClearScopeMemberCache
Request
ClearScopeMemberCache
Response
Clears cache of specified member.
GetAuthorizationDetails GetAuthorizationDetails
Request
GetAuthorizationDetails
Response
Lists the operations that the specified member is authorized to perform.
ListRoleMembers ListRoleMembers
Request
ListRoleMembers
Response
Lists all members assigned to the specified role.
IsAuthorized IsAuthorized
Request
IsAuthorized
Response
Checks if the current user is authorized to perform the specified operation.
IsAuthorizedMany IsAuthorizedMany
Request
IsAuthorizedMany
Response
Checks if the current user is authorized to perform specified operations.
ListAuthorizedScopes ListAuthorizedScopes
Request
ListAuthorizedScopes
Response
Lists Scopes that the member is authorized to operate in. A member is authorized to operate in a Scope if there is at least one operation that he is authorized to perform in that Scope.
GetUserInfo GetUserInfo
Request
GetUserInfo
Response
Retrieves information about the specified user.
GetLastAuthorized GetLastAuthorized
Request
GetLastAuthorized
Response
Retrieves information about the specified user when was last authorized.
SearchByExternalId SearchByExternalId
Request
SearchByExternalId
Response
Removes a member from a role.

Methods with HTTP bindings

CreateRole

  POST /v1/azman-roles  

GetRoleId

  GET /v1/azman-roles/{gk_role_id.value}/id  

GetGkRoleId

  GET /v1/azman-roles/{role_id}/gkid  

DeleteRole

  DELETE /v1/azman-roles/{gk_role_id.value}  

ListRoles

  GET /v1/azman-roles  

CloneRole

  POST /v1/azman-roles/copy  

ResetFactoryRole

  POST /v1/azman-roles/reset  

GetRoleDetails

  GET /v1/azman-roles/{gk_role_id.value}  

SetRoleDescription

  PATCH /v1/azman-roles/{gk_role_id.value}/description  

AddRulesToRole

  POST /v1/azman-roles/{gk_role_id.value}/rules  

RemoveRulesFromRole

  POST /v1/azman-roles/{gk_role_id.value}/rules:batchDelete  

AddMemberToRole

  POST /v1/azman-roles/{gk_role_id.value}/members  

RemoveMemberFromRole

  DELETE /v1/azman-roles/{gk_role_id.value}/members  

SetMemberLabel

  POST /v1/azman-members/set-label  

GetMemberLabel

  GET /v1/azman-members/get-label  

ListAssignedRoles

  GET /v1/azman-members/roles  

ListScopeMembers

  GET /v1/azman-scopes/members  

ClearScopeMemberCache

  DELETE /v1/azman-members/clear-cache  

GetAuthorizationDetails

  GET /v1/azman/members/authorization-details  

ListRoleMembers

  GET /v1/azman-roles/{gk_role_id.value}/members  

IsAuthorized

  GET /v1/azman-members/authorized  

IsAuthorizedMany

  GET /v1/azman-members/authorized-many  

ListAuthorizedScopes

  GET /v1/azman-members/authorized-scopes  

GetUserInfo

  GET /v1/azman-members  

GetLastAuthorized

  GET /v1/azman-members/last-authorized  

SearchByExternalId

  GET /v1/azman-members/search-by-external-id  

azman_messages.proto

AddMemberToRoleRequest

Input message that defines parameters for AddMemberToRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
AddMemberToRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.
member nuance.biosec.v1.Member Mandatory. The member that the method adds the role to.

AddMemberToRoleResponse

Output message that defines parameters returned by AddMemberToRole.

AddMemberToRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

AddRulesToRoleRequest

Input message that defines parameters for AddRulesToRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
AddRulesToRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.
allow repeated string Optional. One or more operations IDs or wildcards that the method adds to the role’s allow list.
deny repeated string Optional. One or more operations IDs or wildcards that the method adds to the role’s deny list.

AddRulesToRoleResponse

Output message that defines parameters returned by AddRulesToRole.

AddRulesToRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

ClearScopeMemberCacheRequest

Input message that defines parameters for ClearScopeMemberCache.

ClearScopeMemberCacheRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question.

ClearScopeMemberCacheResponse

Output message that defines parameters returned by ClearScopeMemberCache.

ClearScopeMemberCacheResponse
Field Type Description
status nuance.rpc.Status General operation status.

CloneRoleRequest

Input message that defines parameters for CloneRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
CloneRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope in which the role should be cloned.
role_id string Mandatory. The new role’s ID. Role IDs are unique in a given scope.
source_gk_role_id nuance.biosec.v1.UniqueId Mandatory. Source role ID to clone from.

CloneRoleResponse

Output message that defines parameters returned by CloneRole.

CloneRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_role_id nuance.biosec.v1.UniqueId The newly created role’s ID. Role IDs are globally unique.

CreateRoleRequest

Input message that defines parameters for CreateRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
CreateRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope in which the role should be created.
role_id string Mandatory. The new role’s ID. Role IDs are unique in a given scope.
description string Optional. The role’s description.

CreateRoleResponse

Output message that defines parameters returned by CreateRole.

CreateRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_role_id nuance.biosec.v1.UniqueId The newly created role’s ID. Role IDs are globally unique.

DeleteRoleRequest

Input message that defines parameters for DeleteRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
DeleteRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.

DeleteRoleResponse

Output message that defines parameters returned by DeleteRole.

DeleteRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

GetAuthorizationDetailsRequest

Input message that defines parameters for GetAuthorizationDetails.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetAuthorizationDetailsRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question.

GetAuthorizationDetailsResponse

Output message that defines parameters returned by GetAuthorizationDetails.

GetAuthorizationDetailsResponse
Field Type Description
status nuance.rpc.Status General operation status.
allowed_rules repeated string List of allowed operations IDs or wildcards.
denied_rules repeated string List of denied operations IDs or wildcards.

GetGkRoleIdRequest

Input message that defines parameters for GetGkRoleId.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetGkRoleIdRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope of the requested Role.
role_id string Mandatory. The role’s ID.

GetGkRoleIdResponse

Output message that defines parameters returned by GetGkRoleId.

GetGkRoleIdResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_role_id nuance.biosec.v1.UniqueId Unique role ID.

GetLastAuthorizedRequest

GetLastAuthorizedRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question.

GetLastAuthorizedResponse

GetLastAuthorizedResponse
Field Type Description
status nuance.rpc.Status General operation status.
last_authorized google.protobuf.Timestamp Date and time of last authorized.

GetMemberLabelRequest

Input message that defines parameters for GetMemberLabel.

GetMemberLabelRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question. Member.type field value is ignored

GetMemberLabelResponse

Output message that defines parameters returned by GetMemberLabel.

GetMemberLabelResponse
Field Type Description
status nuance.rpc.Status General operation status.
label string Gets label for member in question

GetRoleDetailsRequest

Input message that defines parameters for GetRoleDetails.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetRoleDetailsRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.

GetRoleDetailsResponse

Output message that defines parameters returned by GetRoleDetails.

GetRoleDetailsResponse
Field Type Description
status nuance.rpc.Status General operation status.
allowed_rules repeated string Operation IDs or wildcards that are allowed in the role.
denied_rules repeated string Operation IDs or wildcards that are denied in the role.
description string Role description

GetRoleIdRequest

Input message that defines parameters for GetRoleId.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetRoleIdRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope of the requested role.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.

GetRoleIdResponse

Output message that defines parameters returned by GetRoleId.

GetRoleIdResponse
Field Type Description
status nuance.rpc.Status General operation status.
role_id string The role’s ID.

GetUserInfoRequest

Input message that defines parameters for GetUserInfo.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Not used
  • configset_id: Not used
GetUserInfoRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.

GetUserInfoResponse

Output message that defines parameters returned by GetUserInfo.

GetUserInfoResponse
Field Type Description
status nuance.rpc.Status General operation status.
user_info UserInfo User information.
gk_scope_ids repeated nuance.biosec.v1.UniqueId List of Scope IDs.

IsAuthorizedManyRequest

Input message that defines parameters for IsAuthorizedMany. Member identifiers are taken from pre-defined headers.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
IsAuthorizedManyRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context, contains the scope.
operations_ids repeated string Mandatory. The operations IDs in question.

IsAuthorizedManyResponse

Output message that defines parameters returned by IsAuthorized.

IsAuthorizedManyResponse
Field Type Description
status nuance.rpc.Status General operation status.
user_info UserInfo Contains information about the user returned by GetUserInfo.
operations_result repeated OperationResult Contains a list of operations and a boolean value for each operation.

IsAuthorizedRequest

Input message that defines parameters for IsAuthorized. Member identifiers are taken from pre-defined headers.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
IsAuthorizedRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context, contains the scope.
operation_id string Mandatory. The operation ID in question.

IsAuthorizedResponse

Output message that defines parameters returned by IsAuthorized.

IsAuthorizedResponse
Field Type Description
status nuance.rpc.Status General operation status.
is_authorized bool When set to true, the user is authorized to operate in this context.
user_info UserInfo Contains information about the user returned by GetUserInfo.

ListAssignedRolesRequest

Input message that defines parameters for ListAssignedRoles.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListAssignedRolesRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question.

ListAssignedRolesResponse

Output message that defines parameters returned by ListAssignedRoles.

ListAssignedRolesResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_role_ids repeated nuance.biosec.v1.UniqueId List of role IDs.

ListAuthorizedScopesRequest

Input message that defines parameters for ListAuthorizedScopes.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Not used
  • configset_id: Not used
ListAuthorizedScopesRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context, contains the scope.

ListAuthorizedScopesResponse

Output message that defines parameters returned by ListAuthorizedScopes.

ListAuthorizedScopesResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_scope_ids repeated nuance.biosec.v1.UniqueId List of Scope IDs.

ListRoleMembersRequest

Input message that defines parameters for ListRoleMembers.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListRoleMembersRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.

ListRoleMembersResponse

Output message that defines parameters returned by ListRoleMembers.

ListRoleMembersResponse
Field Type Description
status nuance.rpc.Status General operation status.
members repeated nuance.biosec.v1.Member List of members’ information.

ListRolesRequest

Input message that defines parameters for ListRoles.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListRolesRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope that the roles belong to.

ListRolesResponse

Output message that defines parameters returned by ListRoles.

ListRolesResponse
Field Type Description
status nuance.rpc.Status General operation status.
details repeated RoleDetailsForRead List of scopes details.

ListScopeMembersRequest

Input message that defines parameters for ListScopeMembers.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListScopeMembersRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.

ListScopeMembersResponse

Output message that defines parameters returned by ListScopeMembers.

ListScopeMembersResponse
Field Type Description
status nuance.rpc.Status General operation status.
members repeated nuance.biosec.v1.Member Mandatory. The members in question.

OperationResult

Contains operation details.

OperationResult
Field Type Description
allowed bool Determines if the specified operation is allowed.
operation_id string Operation ID.

RemoveMemberFromRoleRequest

Input message that defines parameters for RemoveMemberFromRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
RemoveMemberFromRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.
member nuance.biosec.v1.Member Mandatory. The member that the method removes the role from.

RemoveMemberFromRoleResponse

Output message that defines parameters returned by RemoveMemberFromRole.

RemoveMemberFromRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

RemoveRulesFromRoleRequest

Input message that defines parameters for RemoveRulesFromRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
RemoveRulesFromRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.
allow repeated string Optional. One or more operations IDs or wildcards that the method adds to the role’s allow list.
deny repeated string Optional. One or more operations IDs or wildcards that the method adds to the role’s deny list.

RemoveRulesFromRoleResponse

Output message that defines parameters returned by RemoveRulesFromRole.

RemoveRulesFromRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

ResetFactoryRoleRequest

Input message that defines parameters for ResetFactoryRole.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ResetFactoryRoleRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope in which the Role should be cloned.
role_id string Mandatory. Factory role IDs are unique in a given scope.

ResetFactoryRoleResponse

Output message that defines parameters returned by ResetFactoryRole.

ResetFactoryRoleResponse
Field Type Description
status nuance.rpc.Status General operation status.

RoleDetailsForRead

Contains the readable fields of the scope. Included in ListRolesResponse.

RoleDetailsForRead
Field Type Description
gk_role_id nuance.biosec.v1.UniqueId Role unique ID.
role_id string Role identifier. Must be unique at least at the scope level.

SearchByExternalIdRequest

SearchByExternalIdRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
issuers repeated string Mandatory. List of scope issuers
external_id string Mandatory. External Id in question

SearchByExternalIdResponse

SearchByExternalIdResponse
Field Type Description
status nuance.rpc.Status General operation status.
members repeated nuance.biosec.v1.Member List of members’ information.

SetMemberLabelRequest

Input message that defines parameters for SetMemberLabel.

SetMemberLabelRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
member nuance.biosec.v1.Member Mandatory. The member in question. Member.type field value is ignored

SetMemberLabelResponse

Output message that defines parameters returned by SetMemberLabel.

SetMemberLabelResponse
Field Type Description
status nuance.rpc.Status General operation status.

SetRoleDescriptionRequest

Input message that defines parameters for SetRoleDescription.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
SetRoleDescriptionRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context. Specifies the scope in which the Role should be cloned.
gk_role_id nuance.biosec.v1.UniqueId Mandatory. Unique role ID.
description string Optional. The role’s description.

SetRoleDescriptionResponse

Output message that defines parameters returned by SetRoleDescription.

SetRoleDescriptionResponse
Field Type Description
status nuance.rpc.Status General operation status.

UserInfo

This message contains user details including groups used in GetUserInfoResponse.

UserInfo
Field Type Description
member nuance.biosec.v1.Member Contains user details.
groups repeated string List of groups that the user is assigned to.